#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#define NAME "dreisam"

typedef struct NODE
{
  int no;
  struct NODE * para;
  struct NODE * next;
  int visited;
} SNODE;

SNODE startNode;
long ergebnis,equa;
char* parseFrom;
char ergebnisString[120];


void removeBlanks()
{
  while (*parseFrom==' ') parseFrom++;
}


void buildTree(SNODE* pnode, SNODE* next)
{
  long s;
  /*  char* pHilf;*/

  
  while(1)
    {
      if (*parseFrom=='(')
	{
	  parseFrom++;
	  removeBlanks();
	  pnode->para = (SNODE*) malloc(sizeof(SNODE));
	  pnode->next = 0;
	  pnode->visited = 0;
	  buildTree(pnode->para, pnode);
	  if (*parseFrom == '\0')
	    return;
	  pnode->next = (SNODE*) malloc(sizeof(SNODE));
	  pnode = pnode->next;
	}
      else
	{
	  pnode->para = 0;
	}
      pnode->visited = 0;
      s = 0;
      while(isdigit(*parseFrom))
	{
	  s=s*10 + (long) ((*parseFrom)-'0');
	  parseFrom++;
	}
      pnode->no = s;
      removeBlanks();
      if (*parseFrom=='\0' || *parseFrom==')')
	{
	  pnode->next = next;
	  return;
	}
      pnode-> next = malloc(sizeof(SNODE));
      pnode = pnode->next;
    }
}


int test(SNODE* passedpnode, char c, long val)
{
  SNODE* pnode = passedpnode;

  while(pnode->para)
    {
      pnode->visited = 1;
      pnode = pnode->para;
    }

  if (c=='+')
    newVal = val + pnode->no;
  if (c=='-')
    newVal = val - pnode->no;
  if (c=='*')
    newVal = val * pnode->no;

  done = test(pnode->next,'+');
  if (!done) test(pnode->next,'-');
  if (!done) test(pnode->next,'*');

  while(passedpnode)
    {
      passedpnode->visited = 0;
      passedpnode = passedpnode->next;
    }

  return done;
}




void testAll()
{
  sprintf(ergebnisString,"%ld=",ergebnis);
  printf("Equatation #%ld:\n",equa);
  
  if (!test(&startNode,'+',0));
      printf("Impossible\n");

  printf("\n");
}







int main()
{
  FILE *fin = fopen(NAME ".in", "r");
  char line[90];
  equa = 1;
  while(1)
    {
      fgets(line,sizeof(line),fin);
      if(strcmp(line,"0\n")==0)
	exit(0);
      parseFrom = strstr(line,"=");
      *parseFrom = '\0';
      sscanf(line,"%ld",&ergebnis);
      removeBlanks();
      buildTree(&startNode,NULL);
      testAll();
      equa++;
    }
  
  return 0;
}





 
