#include <stdio.h>
#include <string.h>

#define NAME "lcd"

void dprintf(char* p,...) {}


long s,no;
int begin, firstWritten;

char oa[104][23];


void prepareOutputArray()
{
  int i,j;

  for(i=0;i<104;i++)
    for(j=0;j<23;j++)
      oa[i][j] = ' ';
dprintf("s: %ld no:%ld\n",s,no);
}

void writeZahl(int zahl)
{
  int step;
  int i;

  step = s+2;

 dprintf("Zahl %d\n",zahl);

  if (zahl!=1 && zahl!=4)
    for(i=begin+1;i<begin+s+1;i++)
      oa[i][0] = '-';
  if (zahl!=5 && zahl!=6)
    for(i=1;i<s+1;i++)
      oa[begin+step-1][i] = '|';
  if (zahl!=1 && zahl!=7 && zahl!=0)
    for(i=begin+1;i<begin+s+1;i++)
      oa[i][step-1] = '-';
  if ((zahl>3 && zahl!=7) || zahl==0)
    for(i=1;i<s+1;i++)
      oa[begin][i] = '|';
  if (zahl==2 || zahl==6 || zahl==8 || zahl==0)
    for(i=s+2;i<2*s+2;i++)
      oa[begin][i] = '|';
  if (zahl!=2)
    for(i=s+2;i<2*s+2;i++)
      oa[begin+step-1][i] = '|';
  if (zahl!=1 && zahl!=4 && zahl!=7)
    for(i=begin+1;i<begin+s+1;i++)
      oa[i][2*s+2] = '-';
}

void testNo(long teiler)
{
  int zahl;
  
dprintf("testNo %ld\n",teiler);
  if (!firstWritten) 
    if ((no/teiler)==0) return;
  firstWritten = 1;

  zahl = no/teiler;
  no = no % teiler;
  writeZahl(zahl);  
  begin = begin + s + 3;
dprintf("begin %i\n",begin);
}


void fillOutputArray()
{
  begin = 0;
  firstWritten = 0;

  testNo(10000000);
  testNo( 1000000);
  testNo(  100000);
  testNo(   10000);
  testNo(    1000);
  testNo(     100);
  testNo(      10);

  firstWritten = 1;
  testNo(       1);
}


void doOutput()
{
  int i,j;
  for(i=0;i<(2*s+3);i++)
    {
      oa[begin-1][i] = '\0';
      j = 0;
      while(oa[j][i])
	{
	printf("%c",oa[j][i]);
	j++;
	}
      printf("\n");
    }
  printf("\n");
}

int main()
{
  FILE *fin = fopen(NAME ".in", "r");

  do
    {
      fscanf(fin,"%ld %ld\n",&s,&no);
      if (s!=0 || no!=0)
	{
	  prepareOutputArray();
	  fillOutputArray();
	  doOutput();
	}
    }
  while(s!=0 || no!=0);

  fclose(fin);
  return 0;
}












