
#include <stdio.h>

#define NAME "stree"

#if 0
#define dprintf(x) printf x
#else
#define dprintf(x)
#endif

int main()
{
  FILE *fin = fopen(NAME ".in", "r");
  int n;
  int casenum = 1;

  while (fscanf(fin, "%d ", &n) == 1 && n) {
    enum { maxn = 7 };
    int value[1 << (maxn + 1)];
    int i;
    int permute[maxn];
    int nvva;
    int vva[1 << (maxn + 1)];
    const int N = 1<<n;
    for (i = 0; i < n; i++) {
      fscanf(fin, "x%d ", &permute[i]);
    }
    dprintf(("Values: "));
    for (i=0; i<N; i++) {
      fscanf(fin, "%1d", &value[i]);
      dprintf(("%d", value[i]));
    }
    dprintf(("\n"));
    fscanf(fin, "%d", &nvva);
    printf("S-Tree #%d:\n", casenum++);
    while (nvva--) {
      int what = 0;
      for (i = 0; i<n; i++) {
	fscanf(fin, "%1d", &vva[i]);
      }
      for (i = 0; i<n; i++) {
	dprintf(("perm[%d]=%d\n", i, permute[i]));
	/*	what += vva[permute[i]] ? (1 << i) : 0; */
	what += vva[permute[i]-1] ? (1 << (n-1-i)) : 0;
      }
      dprintf(("what=%d\n", what));
      printf("%d", value[what]);

      dprintf(("\n"));
    }
    printf("\n\n");
  }
  return 0;
}
